(*

  SPINEL

  Vydavatel: Papouch s.r.o. - http://spinel.papouch.com/

  knihovna obsahuje zkladn konstanty, tdy a funkce pro vechny formaty
  protokolu Spinel.

*)

unit uSpinelCore;

interface

const

  PRE = '*';        // prefix paketu vsech formatu Spinelu

  CR  = #13;        // sufix paketu vsech formatu Spinelu

{
type

  TsPacketDirection =
   (
     spd_Unknown,   // chybn paket, nelze urit smr
     spd_INST,      // pkaz
     spd_ACK        // odpov
   );
}

function StrToHesci(S:String):String;       // konverze binrnch dat na HESCI format
function HesciToStr(S:String):String;       // konverze HESCI dat na binrn data

function sCountCRC(PACKET:String):Byte;     // poctn CRC

implementation

uses SysUtils;

function StrToHesci(S:String):String;
var A:integer;
begin
  Result:='';
  For A:=1 to Length(S) do Result:=Result+IntToHex(Ord(S[A]),2);
end;

function HesciToStr(S:String):String;
begin
  Result:='';
  While S<>'' do
  begin
    Result:=Result+Char(StrToInt('$'+Copy(S,1,2)));
    Delete(S,1,2);
  end;
end;

function sCountCRC(PACKET:String):Byte;
var i:word;
begin
  Result:=0;

  For i:=1 to Length(PACKET)
   do Result:=(Result + Ord(PACKET[i])) mod $100;

  Result:=$FF-Result;
end;

end.
